package mc600.boardgames;

import java.util.Vector;

public class BoardPosition {

	protected int boardDimension;
	protected int px;   // Coluna
	protected int py;   // Linha

	protected static final String alphabet = "ABCDEFGHJKLMNOPQRST";
	// No tem I mesmo....

	public BoardPosition(String move, int boardDimension)
		throws InvalidMoveException {
		this.boardDimension = boardDimension;
		String upMove = move.toUpperCase();
		px = alphabet.indexOf(upMove.charAt(0));
		if ((px < 0) || (px >= boardDimension))
			throw new InvalidMoveException("Primeiro char nao e' uma coluna valida");
		String line = "0";
		for (int i = 1; i < upMove.length(); i++) {
			if (!Character.isDigit(upMove.charAt(i)))
				throw new InvalidMoveException("Um dos caracteres da linha  nao e' digito");
			line += upMove.charAt(i);
		}
		py = Integer.parseInt(line) - 1;
	}

	public BoardPosition(int x, int y, int boardDimension) {
		this.boardDimension = boardDimension;
		px = x;
		py = y;
	}

	public int getX() {
		return px;
	}

	public int getY() {
		return py;
	}

	public BoardPosition[] neighbours() {
		Vector viz = new Vector();
		try {
			viz.add(this.up());
		} catch (OutOfBoardException oobe) {
		};
		try {
			viz.add(this.down());
		} catch (OutOfBoardException oobe) {
		};
		try {
			viz.add(this.right());
		} catch (OutOfBoardException oobe) {
		};
		try {
			viz.add(this.left());
		} catch (OutOfBoardException oobe) {
		};
		BoardPosition[] toReturn = new BoardPosition[viz.size()];
		for (int i = 0; i < viz.size(); i++) {
			toReturn[i] = (BoardPosition) viz.elementAt(i);
		}
		return toReturn;
	}

	public BoardPosition up() throws OutOfBoardException {
		BoardPosition bp = new BoardPosition(px, py + 1, boardDimension);
		if (!bp.inBoard())
			throw new OutOfBoardException("Posicao fora do tabuleiro");
		return bp;
	}

	public BoardPosition down() throws OutOfBoardException {
		BoardPosition bp = new BoardPosition(px, py - 1, boardDimension);
		if (!bp.inBoard())
			throw new OutOfBoardException("Posicao fora do tabuleiro");
		return bp;
	}

	public BoardPosition left() throws OutOfBoardException {
		BoardPosition bp = new BoardPosition(px - 1, py, boardDimension);
		if (!bp.inBoard())
			throw new OutOfBoardException("Posicao fora do tabuleiro");
		return bp;
	}

	public BoardPosition right() throws OutOfBoardException {
		BoardPosition bp = new BoardPosition(px + 1, py, boardDimension);
		if (!bp.inBoard())
			throw new OutOfBoardException("Posicao fora do tabuleiro");
		return bp;
	}

	protected boolean inBoard() {
		return (
			(px >= 0)
				&& (px < boardDimension)
				&& (py >= 0)
				&& (py < boardDimension));
	}

}
