package mc600.boardgames;

import java.io.BufferedReader;
import java.io.InputStreamReader;

import junit.framework.TestCase;

public class TanboBoardTest extends TestCase {

	public TanboBoardTest(String arg0) {
		super(arg0);
	}

	public void testBoard() {
		try {
			BufferedReader stdin =
				new BufferedReader(new InputStreamReader(System.in));
			TanboBoard board = new TanboBoard(9);
			int[][] b = board.positions;
			for (int i = board.dimension - 1; i >= 0; i--) {
				for (int j = 0; j < board.dimension; j++) {
					System.out.print(b[j][i]);
				}
				System.out.println();
			}
			printRoots(board);
			int turn = 0;
			boolean isBlack = false;
			String move = null;
			do {
				isBlack = (turn % 2 == 0);
				if (isBlack) {
					System.out.print("BLACK: ");
				} else {
					System.out.print("WHITE: ");
				}
				turn++;
				move = stdin.readLine();
				board.play(move, isBlack);
				printRoots(board);
				b = board.positions;
				String linhas = "ABCDEFGHJ";
				System.out.println("123456789");
				for (int i = board.dimension - 1; i >= 0; i--) {
					for (int j = 0; j < board.dimension; j++) {
						System.out.print(b[i][j]);
					}
					System.out.println(" "+ linhas.charAt(i));
				}
			} while (!board.gameOver());
			System.out.println("GAME OVER: "+board.winner());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private void printRoots(TanboBoard board) {
		System.out.println("\n BLACK ROOTS ");
		for (int i = 0; i < board.blackRoots.size(); i++) {
			((Root) board.blackRoots.elementAt(i)).print();
		}
		System.out.println("\n WHITE ROOTS ");
		for (int i = 0; i < board.whiteRoots.size(); i++) {
			((Root) board.whiteRoots.elementAt(i)).print();
		}
	}

}
