package mc600.gamemanager;


public class Player {
    protected final static String MAGIC = "Tanbo MC600 Oct 2003";

    // Lance que indica que o jogador deve iniciar partida
    public 	  final static String STARTCMD = "ST";
    private String playerName;
    // Tamanho do lance
    public final static int MOVESIZE = 2;			
    // Faixa inicial de enderecos IP
    protected final static int MINIP = 30000;			
    // Faixa final para enderecos IP
    protected final static int MAXIP = 30149;			
    // Tamanho maximo do nome do jogador
    public final static int MAXPLAYERNAME = 256;		

    // Tempo maximo de espera por lance de jogador (milisegundos)
    public final static int MAXRESPONSETIME = 5000;
    // Tempo maximo de espera na validacao do jogador (milisegundos)
    public final static int MAXVALIDATETIME = 5000;
    // Tempo maximo da partida (milisegundos)
    public final static int MAXGAMETIME     = 50000;  
    public final static int DIM = 9;

    /**
     * Insert the method's description here.
     * Creation date: (3/8/00 7:38:40 PM)
     * @param ip java.lang.String
     * @param port int
     * @param email java.lang.String
     * @exception java.lang.Exception The exception description.
     */
    public Player(String id){

	// Salva id como playerName
	playerName = id;
	
    }

    // converte o lance xy num inteiro, shiftando os bytes....
    public static int moveToInt(String move){
	int c1,c2;
	int imove=0;

	c1 = move.charAt(0);
	c2 = move.charAt(1);

	imove = c1;
	imove |= (c2 << 8);

	return(imove);

    }

    /**
     * Insert the method's description here.
     * Creation date: (3/23/00 12:51:29 AM)
     * @return java.lang.String
     */
    public String getPlayerName() {
	return playerName;
    }

    // converte o inteiro em lance, shiftando os bytes
    public static String intToMove(int imove){

	char c1,c2;
	StringBuffer move = new StringBuffer(MOVESIZE);

	c1 = (char) (imove & 0xFF);
	c2 = (char) ((imove >> 8)  & 0xFF);

	move.append(c1);
	move.append(c2);
	
	return (new String(move.toString()));

    }

    /**
     * Insert the method's description here.
     * Creation date: (3/23/00 12:51:29 AM)
     * @param newPlayerName java.lang.String
     */
    protected void setPlayerName(String newPlayerName) {

	if (newPlayerName.length() <= MAXPLAYERNAME)
	    playerName = newPlayerName;
	else
	    playerName = "Nome-Muito-Comprido";
    }
}
